#
# Copyright (c) 2023, HILSTER - https://hilster.io
# All rights reserved.
#

from typing import Any, Optional

import htf_libusb as usb  # type: ignore
from dataclasses import dataclass, field


@dataclass()
class USBDevice:
    device: Any
    vendor_id: int
    product_id: int
    bus: int
    address: int


@dataclass()
class LabJackUSBDevice:
    device: Any
    vendor_id: int
    product_id: int
    bus: int
    address: int
    busy: bool
    ethernet_ip: Optional[str]
    wifi_ip: Optional[str]
    name: Optional[str]
    handle: Optional[Any] = field(init=False)

    def close(self) -> None:
        if self.handle:
            usb.close(self.handle)
