#
# Copyright (c) 2023, HILSTER - https://hilster.io
# All rights reserved.
#

#
# Copyright (c) 2023, HILSTER - https://hilster.io
# All rights reserved.
#

from typing import Optional, List

import htf.io.core
import logging
import argparse
import sys

logger = logging.getLogger(__name__)


class LabJackCLI:
    """
    A LabJack command line interface.
    """

    def __init__(
        self,
        argv: Optional[List[str]] = None,
    ):
        """
        Args:
            argv=None: used for testing, etc.
        """
        if argv is None:
            argv = sys.argv

        self.command = ""
        self._parse_arguments(argv)
        self._run()

    def _parse_arguments(self, argv: List[str]) -> None:
        self._main_parser = argparse.ArgumentParser(
            description="labjack - HILSTER Testing Framework (HILSTER, https://hilster.io)"
        )

        self._subparsers = self._main_parser.add_subparsers(dest="command", help="the command")
        self._subparsers.required = True

        self._list_parser = self._subparsers.add_parser("list", help="List LabJack devices")

        self._main_parser.parse_args(argv[1:], self)

    def _run(self) -> None:
        if self.command == "list":
            htf.io.core.list_labjack_devices()
        exit(0)


def main() -> None:
    LabJackCLI()
    exit(0)


if __name__ == "__main__":
    main()
